import java.lang.*;
import java.util.*;
import java.awt.*;
import java.applet.*;



public class MountainApplet extends Applet{
  public MountainCanvas canv;
  public Button         divide_button;
  public Button         zoom_in_button;
  public Button         zoom_out_button;
  public Button         clear_button;
  public Button         wireframe_button;
  public Button         zbuffer_button;
  public Button         pers_button;
  public Button         para_button;
  public TextField      roughness_input;
  public Label          proj_label;
  public void start(){
    canv            = new MountainCanvas(400,400);
    divide_button   = new Button("Divide");
    zoom_in_button  = new Button("Zoom In");
    zoom_out_button = new Button("Zoom Out");
    clear_button    = new Button("Clear");
    zbuffer_button  = new Button("ZBuffer");
    wireframe_button = new Button("WireFrame");
    pers_button      = new Button("Perspective");
    para_button      = new Button("Parallel");
    roughness_input = new TextField("0.13");
    proj_label      = new Label("Proj mode = Perspective");

    setLayout(null);
    canv.move(20,20);
    canv.resize(400,400);
    add(canv);
    canv.makeOffScreen();
    canv.setBackground(Color.black);
    canv.set_roughness(0.13);
    divide_button.move(20,430);
    divide_button.resize(70,20);
    divide_button.show();
    add(divide_button);

    zoom_in_button.move(100,430);
    zoom_in_button.resize(70,20);
    zoom_in_button.show();
    add(zoom_in_button);

    zoom_out_button.move(200,430);
    zoom_out_button.resize(70,20);
    zoom_out_button.show();
    add(zoom_out_button);

    clear_button.move(300,430);
    clear_button.resize(70,20);
    clear_button.show();
    add(clear_button);

    zbuffer_button.move(20,460);
    zbuffer_button.resize(70,20);
    zbuffer_button.show();
    add(zbuffer_button);

    wireframe_button.move(100,460);
    wireframe_button.resize(70,20);
    wireframe_button.show();
    add(wireframe_button);

    pers_button.move(200,460);
    pers_button.resize(80,20);
    pers_button.show();
    add(pers_button);
    
    para_button.move(300,460);
    para_button.resize(80,20);
    para_button.show();
    add(para_button);


    roughness_input.move(400,460);
    roughness_input.resize(70,40);
    roughness_input.show();
    add(roughness_input);
    
    proj_label.move(20,510);
    proj_label.resize(250,30);
    proj_label.show();
    add(proj_label);

    canv.draw_clear();
    canv.draw();
    canv.repaint();
  }

  public boolean action(Event e, Object what){
    if( e.target == divide_button ){
      canv.set_roughness((new Double(roughness_input.getText())).doubleValue());
      canv.divide();
    }
    else if( e.target == zoom_in_button ){
      canv.zoom(100);
    }
    else if( e.target == zoom_out_button ){
      canv.zoom(100);
    }
    else if( e.target == clear_button ){
      canv.set_roughness((new Double(roughness_input.getText())).doubleValue());
      canv.clear_mountain();
    }
    else if( e.target == zbuffer_button ){
      canv.setDrawMode(MountainCanvas.ZBUF);
    }
    else if( e.target == wireframe_button ){
      canv.setDrawMode(MountainCanvas.WIRE_FRAME);
    }
    else if( e.target == pers_button ){
      canv.setProjMode(MountainCanvas.PERS);
      proj_label.setText("proj mode = Perspective");
    }
    else if( e.target == para_button ){
      canv.setProjMode(MountainCanvas.PARA);
      proj_label.setText("proj mode = Parallel");
    }
    else if( e.target == roughness_input ){
      canv.set_roughness((new Double(roughness_input.getText())).doubleValue());
    }
    return false;
  }
 
}
