/*
 $BFs<!85B?3Q7A$NAv::JQ49(B
*/


import java.lang.*;
import java.util.*;
import java.awt.*;

public class ScanConversion{

  public static class tdEdge{
    public Point s;
    public Point e;

    public tdEdge(Point start, Point end){
      this.s = start;
      this.e   = end;
    }

    public Point getLeft(){ 
      // s.x == e.x --> s
      if( s.x <= e.x ){ return s; }else{ return e; }
    }

    public Point getRight(){
      // s.x == e.x --> e
      if( s.x > e.x ){ return s; }else{	return e; }
    }

    public Point getUpper(){
      // s.y == e.y --> s
      if( s.y >= e.y ){ return s; }else{ return e; }
    }

    public Point getLower(){
      // s.y == e.y --> e
      if( s.y < e.y ){ return s; }else{	return e; }
    }
    
    public void shortenUpper(){
      Point u = getUpper();
      Point l = getLower();
      int dx  = l.x - u.x;
      int dy  = u.y - l.y;
       
      u.y -= 1;

      if( dx > 0 ){
	if( dx+dx >= dy ){
	  u.x += 1;
	}
      }
      else if( dx < 0){
	if( -(dx+dx) >= dy ){
	  u.x -= 1;
	}
      }
    }

    public void shortenLower(){
      Point u = getUpper();
      Point l = getLower();
      int dx  = u.x - l.x;
      int dy  = u.y - l.y;

      l.y += 1;
      if( dx > 0 ){
	if( dx+dx >= dy ){
	  l.x += 1;
	}
      }
      else if( dx < 0){
	if( -(dx+dx) >= dy ){
	  l.x -= 1;
	}
      }
     
    }      
  }    

  public ScanConversion(){}
  
  public void fillPolygon(Point[] poly, Graphics g){
    /* Fill polygon defined by poly onto g */
    
    if( poly.length < 3 ){ return; }

    int miny,maxy;
    int poly_height;

    tdEdge[]        edges;
    IntegerList[] intersects_table;
   
    miny = poly[0].y;
    maxy = poly[0].y;
    
    for( int i = 0; i < poly.length; i++ ){
      Point p = poly[i];
      int   y = p.y;
          
      if( miny > y ){ miny = y; }
      if( maxy < y ){ maxy = y; }
    }

    poly_height = maxy - miny + 1;

    /* $BD:E@$+$iJU$r:n$k(B */
    edges = makeEdge(poly);

    /* $B8rE@%j%9%HI=$r:n$k(B */
    intersects_table = makeIntersectsTable(miny, maxy, edges);
    
    /* $B%9%-%c%s$7$F$+$/(B */
    for( int i = 0; i < poly_height; i++ ){
      int          scan = miny + i;
      IntegerList  list = intersects_table[i];
     
      /* list.length = 2*n (n != 0) $B$N$O$:$G$"$k(B */
      list.moveTop();
     
      for(int j = 0; j < list.size() - 1; j+=2){
	int x1 = list.nextElement();
	int x2 = list.nextElement();
	// $B@~$r0z$/(B (x1,scan) ---- (x2,scan)
	// - $B$O(B $B:BI87O$r(BJava$B:BI8$K$+$($k$?$a(B
	g.drawLine(x1,-scan, x2,-scan);
	
      }
    }
  }

  public tdEdge[] makeEdge(Point[] poly){
    Point  p1;
    Point  p2;
    int x1,y1,x2,y2;

    Vector edges = new Vector();
    p1        = poly[poly.length - 1];
   
    int prevY;
    int k = poly.length - 2;
    while( k > 0 && poly[k].y == p1.y ){
      k--;
    }
    prevY = poly[k].y;
    

    for( int i = 0; i < poly.length; i++ ){
      p2 = poly[i];
      
      /* $B?eJ?$JJU$O=|$/(B */
      if( p1.y != p2.y ){
	tdEdge e = new tdEdge(new Point(p1.x,p1.y), 
			  new Point(p2.x,p2.y));
	
	/* $BC1D4$KA}2C$^$?$O8:>/$9$kJU$N$H$-$O(B
	   $B$o$6$HC;$/$7$F$9$-4V$r$"$1$k(B */
	if((prevY < p1.y) && (p1.y < p2.y)){
	  e.shortenLower();
	}
	else if((prevY > p1.y) && (p1.y > p2.y)){
          e.shortenUpper();
	}
	prevY = p1.y;
	edges.addElement(e);
      }
     
      p1    = p2;
    }

    tdEdge[] ret = new tdEdge[edges.size()];
    for( int i = 0; i < ret.length; i++ ){
      ret[i] = (tdEdge)edges.elementAt(i);
    }

    return ret;
  }

  public IntegerList[] makeIntersectsTable(int miny, int maxy, tdEdge[] edges){

    IntegerList[] list = new IntegerList[maxy - miny + 1];
    for( int i = 0; i < list.length; i++ ){
      list[i] = new IntegerList();
    }
    
    for( int i = 0; i < edges.length; i++ ){
      tdEdge  e = edges[i];
      Point l = e.getLeft();
      Point r = e.getRight();
      
      int dx = r.x - l.x;
      int dy = r.y - l.y;
      /* dy = 0 $B$N$b$N$O$U$/$^$l$J$$$H$9$k(B */
      double im = Math.abs(dx/(double)dy);
      
     
      int y    = l.y;
      int yInc = 0;
      int pdy  = 0;
      
      if( dy < 0 ){ yInc = -1; pdy = - dy; }
      else if( dy > 0 ){ yInc = 1; pdy = dy; }

      for(int j = 0; j <= pdy ; j++){
	list[y - miny].insertInc(l.x + (int)((double)j*im));
	y += yInc;
      }
    }
    return list;
  }
}
	  
    
    
