import java.util.*;
import java.awt.*;

public class ScanConversionCanvas extends BCanvas{
  public static boolean debug = true;


  public Color back_color  = Color.white;
  public Color point_color = Color.blue;
  public Color edge_color  = Color.black;
  public Color active_edge_color = Color.red;
  public Color fill_color  = Color.gray; 

  public Vector points;
  public int point_size = 4;
 
  public ScanConversionCanvas(int width, int height){
    super(width,height);
    points = new Vector();
  }

  public void paint(Graphics g){
    if( offs != null ){
      g.drawImage(offs,0,0,this);
    }
  }


  public void draw_clear(){
    offsg.setColor(back_color);
    // jdk1.1 $B$G$O(B size() --> getSize()
    offsg.fillRect(0,0,size().width, size().height);
  }

  public void draw(){
  
    if( offsg == null ){ return; }
  
    offsg.setColor(point_color);
    if( points.size() >= 1 ){
      for( int i = 0; i < points.size(); i++ ){
	Point p = (Point)points.elementAt(i);
	offsg.fillArc(p.x-point_size/2,
		      p.y-point_size/2,
		      point_size,
		      point_size,
		      0,360);
      }
    }
    
    offsg.setColor(edge_color);
    if( points.size() >= 2 ){
      Point p1,p2;
      for( int i = 0; i < points.size() - 1 ; i++ ){
	p1 = (Point)points.elementAt(i);
	p2 = (Point)points.elementAt(i+1);
	offsg.drawLine(p1.x, p1.y, p2.x, p2.y);
      }
      p1 = (Point)points.elementAt(0);
      p2 = (Point)points.elementAt(points.size()-1);
      offsg.drawLine(p1.x, p1.y, p2.x, p2.y);
    }
    
    
  }

  public void go(){
    draw_clear();
    if( (points.size() >= 3) ){
      Point[] ps = new Point[points.size()];
      for( int i = 0; i < ps.length; i++ ){
	Point p = (Point)points.elementAt(i);
	ps[i] = new Point(p.x, p.y);
	ps[i].y = - ps[i].y;
      }
      offsg.setColor(fill_color);
      (new ScanConversion()).fillPolygon(ps, offsg);
    }
    draw();
    paint(getGraphics());
  }

  public void clear(){
    points = new Vector();
    draw_clear();
    draw();
    paint(getGraphics());
  }
    
  public boolean mouseExit(Event e, int x, int y){
    draw_clear();
    draw();
    paint(getGraphics());
    return false;
  }

  public boolean mouseMove(Event e, int x, int y){
    draw_clear();
    draw();
    if( points.size() >= 1 ){
      Point fst  = (Point)points.elementAt(0);
      Point last = (Point)points.elementAt(points.size()-1);
      offsg.setColor(active_edge_color);
      offsg.drawLine(fst.x, fst.y, x, y);
      offsg.drawLine(last.x, last.y, x, y);
    }
    paint(getGraphics());
    return false;
  }

  public boolean mouseDown(Event e, int x, int y){
    if( debug ){
      System.out.println("(" + x + ", " + y + ")");
    }
    Point np = new Point(x,y);
    points.addElement(np);
    draw_clear();
    draw();
    paint(getGraphics());
    return false;
  }
}


